<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;
use App\Http\Models\ItempenggunaanmakananModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;
class ItempenggunaanmakananService extends BaseService
{
    /**
     ItempenggunaanmakananService constructor.
    */
    public function __construct()
    {
        parent::__construct();
        $this->model= new ItempenggunaanmakananModel();
    }

	/**
	*  index function that get all data from database by default
	*  @return array|static[]
	*/
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	*  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	*  @param array $input
	*  @return array
	*/
	public function paging($input)
	{
		$this->model->joinRelationItemId()->joinRelationLocationId()->getQuery()->select(["itempenggunaanmakanan.*",
		"locationId.namaLokasi as namaLokasi",
		"itemId.namaItem as namaItem"]);
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	*  get one raw row data from table by id
	*  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	*  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	*  and you want to take value like this $model->fieldname
	*  @param $id
	*  @return ItempenggunaanmakananModel
	*/
	public function show($id)
	{
		$model=$this->model->getQuery()->where("itempenggunaanmakanan.id","=",$id)->first();
		return $model;
	}


	/**
	*  this is a base function for storing data you with transaction by default
	*  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	*  @param array $input
	*  @return ItempenggunaanmakananModel
	*  @throws \Exception
	*/
	public function store($input)
	{
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			$newInput = $this->getPrepare($input);
			if(! empty($newInput)) {
				/* if(! $this->model->insert($newInput)) {
					throw new \Exception();
				} */
				foreach($newInput as $row) {
					$itemBrg = new ItempenggunaanmakananModel();
					$itemBrg->fill($row);
					if(! $itemBrg->save()) {
						throw new \Exception();
					}
				}
				return $this->model;
			}
		}
	}

	private function getPrepare($input) {
		$data = [];
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			foreach($input["itemID"] as $stokID => $itemID) {
				$data[] = [	"msNumber" 		=> $input["msNumber"],
							"itemId" 		=> $itemID,
							"lotNumber" 	=> $input["lotNumber"][$stokID],
							"locationId" 	=> $input["locationId"][$stokID],
							"quantity" 		=> $input["quantity"][$stokID],
							"stokId" 		=> $input["stokID"][$stokID],
							"harga" 		=> $input["harga"][$stokID],
							"harga_satuan" 	=> $input["harga_satuan"][$stokID]
				];
			}
		}
		return $data;
	}


	/**
	* this function will delete much data, in one action
	* the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	* you can remove this main alogorithm with your business requirement like soft delete or anything you want
	*  @param $ids
	*/
	public function delete($ids){
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	*  this is a base function for update and delete data by default.
	*  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	*  you can add multiple relation proses after update in this function 
	*  @param $id
	*  @param array $input 
	*  @return ItempenggunaanmakananModel
	*  @throws \Exception
	*/
	public function update($id,$input)
	{
		$itempenggunaanmakanan=ItempenggunaanmakananModel::find($id);
		$itempenggunaanmakanan->fill($input);
		if(!$itempenggunaanmakanan->update()){
			throw new \Exception();
		}
		return $itempenggunaanmakanan;
	}


	/**
	*  this function will be confirting paging property into file excel
	*  the main library is base on excel spreadsheet library
	*  @param array $input
	*   @return array|static[]
	*/
	public function exportToExcel($input =array())
	{
		return $this->model->getQuery()->get();
	}

	public function showBasedOnPenggunaanMakanan($request, $headerTransaction) {
		$auth = json_decode($request->session()->get('auth'));

		$model = $this->model->joinRelationItemId()->joinRelationStokId()->joinRelationLocationId()->getQuery()
		->where("itempenggunaanmakanan.msNumber", "=", $headerTransaction->msNumber)
		->where("itemId.kapalId", "=", $headerTransaction->kapalId)
		// ->where("locationId.kapalId", "=", $headerTransaction->kapalId)
		->whereIn("itemId.type_id", $auth->arrCategory)
		->whereIn("itempenggunaanmakanan.locationId", $auth->arrLokasi)
		->select([	"itempenggunaanmakanan.*",
					"locationId.namaLokasi as namaLokasi",
					"itemId.namaItem as namaItem",
					"itemId.category as category",
					"itemId.item_price as harga_satuan",
					"itemId.deskripsi as deskripsi",
					"stokId.jumlah as qtyStock",
					"itemId.UOM as UOM"])->get();
		return $model;
	}

	public function getRekapitulasi($kapalId, $voyageKode, $dateStart, $dateEnd) {
		$this->model->joinRelationPenggunaanMakananId()->joinRelationItemId()->getQuery()
		->where("penggunaanMakananId.voyageKode", "=", $voyageKode)
		->where("penggunaanMakananId.status", "=", "1")
		->where("penggunaanMakananId.kapalId", "=", $kapalId)
		// ->whereRaw('"penggunaanMakananId"."date" BETWEEN  \'' . $dateStart . '\' AND \'' . $dateEnd . '\' ')
		->selectRaw(' "itemId"."deskripsi", "itemId"."meal_class", "itempenggunaanmakanan"."harga_satuan", SUM("itempenggunaanmakanan"."quantity") AS "nItem", "itempenggunaanmakanan"."itemId", SUM("itempenggunaanmakanan"."harga") AS "harga" ');
		if($voyageKode <= 0) {
			$this->model->getQuery()->whereRaw('"penggunaanMakananId"."date" BETWEEN  \'' . $dateStart . '\' AND \'' . $dateEnd . '\' ');
		}
		$model = $this->model->getQuery()->groupBy("itempenggunaanmakanan.itemId")
		->groupBy("itempenggunaanmakanan.harga_satuan")
		->groupBy("itemId.deskripsi")
		->groupBy("itemId.meal_class")
		->orderBy("itemId.meal_class", "ASC")
		->orderBy("itemId.deskripsi", "ASC")
		->get();

		/* $arrItems = [];
		foreach($model as $row) {
			$arrItems[$row->itemId . $row->harga_satuan]  = ["itemId" => $row->itemId, "qty" => $row->nItem, "harga" => $row->harga, "harga_satuan" => $row->harga_satuan];
		}

		return $arrItems; */

		return $model;
	}
}